/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#ifndef _DATAITEMSEQUENCE_HPP
#define _DATAITEMSEQUENCE_HPP

#include <pathan/Pathan.hpp>
#include <pathan/dataItem/DataItemImpl.hpp>
#include <pathan/Sequence.hpp>

class Item;
class XPath2MemoryManager;
class DynamicContext;

/** deals with the numeric data type */
class PATHAN_EXPORT DataItemSequence : public DataItemImpl
{

public:
  DataItemSequence(const Sequence &s, XPath2MemoryManager* memMgr);
	DataItemSequence(const Item* b, XPath2MemoryManager* memMgr);
	DataItemSequence(XPath2MemoryManager* memMgr);

  ~DataItemSequence();

  /**
   * Called during static analysis to determine if statically correct.
   * Performs constant folding of predicates, if possible.
   */
  virtual DataItem* staticResolution(StaticContext *context, StaticResolutionContext *src);
  virtual DataItemImpl *resolvePredicate(VectorOfDataItems::reverse_iterator it, VectorOfDataItems &newPreds, DynamicContext *context, StaticResolutionContext *src);

	//collapase the compiled expression based on context
	virtual Sequence collapseTreeInternal(DynamicContext* context, int flags=0) const;

private:
	Sequence _sequence;
};

#endif
