/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#ifndef _FUNCTIONSUBTRACTDATETIMESYIELDINGDAYTIMEDURATION_HPP
#define _FUNCTIONSUBTRACTDATETIMESYIELDINGDAYTIMEDURATION_HPP

#include <pathan/Pathan.hpp>

#include <pathan/dataItem/DataItemFunction.hpp>

/**
 * Calculates the dayTimeDuration that is the difference between two
 * dateTimes.
 *
 *   subtract-dateTimes-yielding-dayTimeDuration(dateTime $srcval1, 
 *   dateTime $srcval2) => dayTimeDuration
 */
class PATHAN_EXPORT FunctionSubtractDateTimesYieldingDayTimeDuration : public DataItemFunction
{
public:
  static const XMLCh name[];


  /**
   * Constructor.
   */
  FunctionSubtractDateTimesYieldingDayTimeDuration(const VectorOfDataItems &args, XPath2MemoryManager* memMgr);

  DataItem* staticResolution(StaticContext *context, StaticResolutionContext *src);

  /**
   * Returns the dayTimeDuration that corresponds to the difference
   * between the value of $srcval1 and the value of $srcval2
   */
  Sequence collapseTreeInternal(DynamicContext* context, int flags=0) const;
};

#endif // _FUNCTIONSUBTRACTDATETIMESYIELDINGDAYTIMEDURATION_HPP



