/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

/*
   Equals operator function
*/

#ifndef _EQUALS_HPP
#define _EQUALS_HPP

#include <pathan/Pathan.hpp>

#include <pathan/dataItem/DataItemOperator.hpp>

/** OpEqualsEquals operator function*/
class PATHAN_EXPORT Equals : public DataItemOperator
{
public:
  static const XMLCh name[];

  Equals(const VectorOfDataItems &args, XPath2MemoryManager* memMgr);
  
  static bool equals(const Item* arg1, const Item* arg2, DynamicContext* context);

  /** Returns whether two dataItems are equal. */
  Sequence collapseTreeInternal(DynamicContext* context, int flags=0) const;

};

#endif // _EQUALS_HPP

