/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

/*
   General Comparison operator function
*/

#ifndef _GENERALCOMP_HPP
#define _GENERALCOMP_HPP

#include <pathan/Pathan.hpp>

#include <pathan/dataItem/DataItemOperator.hpp>

/** GeneralComp operator function*/
class PATHAN_EXPORT GeneralComp : public DataItemOperator
{
public:
  typedef enum {
    EQUAL,
    NOT_EQUAL,
    LESS_THAN,
    LESS_THAN_EQUAL,
    GREATER_THAN,
    GREATER_THAN_EQUAL
  } ComparisonOperation;

  static const XMLCh name[];

  GeneralComp(ComparisonOperation operation, const VectorOfDataItems &args, XPath2MemoryManager* memMgr);

  /** Returns whether two dataItems are in the specified order. */
  Sequence collapseTreeInternal(DynamicContext* context, int flags=0) const;

  ComparisonOperation getOperation() const;

protected:
  ComparisonOperation _operation;

};

#endif // _GENERALCOMP_HPP



