/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

/*
   GreaterThan operator function
*/

#ifndef _GREATERTHAN_HPP
#define _GREATERTHAN_HPP

#include <pathan/Pathan.hpp>

#include <pathan/dataItem/DataItemOperator.hpp>

/** OpGreaterThan operator function*/
class PATHAN_EXPORT GreaterThan : public DataItemOperator
{
public:
  static const XMLCh name[];

  GreaterThan(const VectorOfDataItems &args, XPath2MemoryManager* memMgr);
  
  static bool greater_than(const Item* arg1, const Item* arg2, DynamicContext* context);

  /** OpGreaterThan Takes two DataItems a and b and returns (a > b)*/
  Sequence collapseTreeInternal(DynamicContext* context, int flags=0) const;

};
#endif
