/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

/*
   LessThanEqual operator function
*/

#ifndef _LESSTHANEQUAL_HPP
#define _LESSTHANEQUAL_HPP

#include <pathan/Pathan.hpp>

#include <pathan/dataItem/DataItemOperator.hpp>

/** OpLessThanEqual operator function*/
class PATHAN_EXPORT LessThanEqual : public DataItemOperator
{
public:
  static const XMLCh name[];

  LessThanEqual(const VectorOfDataItems &args, XPath2MemoryManager* memMgr);
  
  static bool less_than_equal(const Item* arg1, const Item* arg2, DynamicContext* context);

  /** OpLessThanEqual Takes two DataItems a and b and returns (a <= b)*/
  Sequence collapseTreeInternal(DynamicContext* context, int flags=0) const;

};

#endif // _LESSTHANEQUAL_HPP

