/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

/*
   Union function -- takes two sequences, and merge them
*/

#ifndef _UNION_HPP
#define _UNION_HPP

#include <pathan/Pathan.hpp>

#include <pathan/dataItem/DataItemOperator.hpp>

/** Union operator function*/
class PATHAN_EXPORT Union : public DataItemOperator
{
public:
  static const XMLCh name[];

  Union(const VectorOfDataItems &args, XPath2MemoryManager* memMgr);
  
  /** Takes two lists and returns the union of them (with each node unique in the resulting list) */
  Sequence collapseTreeInternal(DynamicContext* context, int flags=0) const;

};

#endif // _UNION_HPP

